; =======================================
; ===== PANTHER GAMES ENHANCER 2v1 ======
; =======================================
;
; Mark Kratzer on 07/03/10 (updated 11/28/15)
;
; 07/04/10 - Fixed window name matching problem.
;
; 01/18/11 - Implemented PGEv03 (persistence, tweak hot spots, WYSIWYG)
;
; 11/28/15 - Removed support for all games but CO2.
;            Removed unspupported HTTR/COTA/BFTB code.  PGE1v3 can be run
;              for those games.
;            Included support for multiple windows/displays.
;            Recoded for removal of ALT-CLICK zooming functionality.
;            Adjusted to new size of strat map and possible absence of control
;            Compiled version upgraded to AutoHotkey112209_Install.exe
;              ANSI 32 bit.
;            Only three levels of zoom now supported.
;            Added MR arg to reverse mouse scrolling (not working)
;
; 12/05/15  Handle overlapping (landing area) hot spots.

; ----------------------
; ----- Initialize -----
; ----------------------

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
SetTitleMatchMode 3 ; Exact matches required.
DetectHiddenWindows, Off
SetKeyDelay, , 100,
SetMouseDelay, 100,

DelayMap:=1 ; delay between map moves (reduced from 10 for CO2)
DelaySound:=500 ; delay between ding confirmations

LastFKey:=0 ; UNDEFINED - the last location set or recalled (F-Key #)

OnExit, ExitHandler

; --------------------------------------
; ----- Test for command line args ----- THIS CODE NOT WORKING
; --------------------------------------

;If 0=0
;{
;  MR:=0
;}
;Else
;{
;  If 1=MR
;  {
;    MR:=1
;  }
;  Else
;  {
;    MR:=-1
;  }
;}
;If MR=-1
;{
;  MsgBox, 0, PGE2, Invalid command line parameter.  Expected only "MR" for reverse scroll.
;  ExitApp
;}
MR:=0

MsgBox, 0, PGE2v1 (07/03/10-11/28/15) by Mark "MarkShot" Kratzer, WARNING:  This utility will only work if the CONTROLS WINDOW is kept open (at any location, on any display) and REVERSE MOUSE ZOOM is selected!!!

MsgBox, 4, PGE2, Load hot spots from INI?

IfMsgBox, No
{
          ; UNDEFINED - these are the locations and zoom levels for each hot spot
  F01X:=0
  F01Y:=0
  F01Z:=0
  
  F02X:=0
  F02Y:=0
  F02Z:=0
  
  F03X:=0
  F03Y:=0
  F03Z:=0
  
  F04X:=0
  F04Y:=0
  F04Z:=0
  
  F05X:=0
  F05Y:=0
  F05Z:=0
  
  F06X:=0
  F06Y:=0
  F06Z:=0
  
  F07X:=0
  F07Y:=0
  F07Z:=0
  
  F08X:=0
  F08Y:=0
  F08Z:=0
  
  F09X:=0
  F09Y:=0
  F09Z:=0
  
  F10X:=0
  F10Y:=0
  F10Z:=0
  
  F11X:=0
  F11Y:=0
  F11Z:=0
  
  F12X:=0
  F12Y:=0
  F12Z:=0
  
  SetDefZoom(1, 1) ; Set up initial zoom
}
else
{
  IniRead, F01X, PGE.INI, HotSpots, F01X, 0
  IniRead, F01Y, PGE.INI, HotSpots, F01Y, 0
  IniRead, F01Z, PGE.INI, HotSpots, F01Z, 0
                                       
  IniRead, F02X, PGE.INI, HotSpots, F02X, 0
  IniRead, F02Y, PGE.INI, HotSpots, F02Y, 0
  IniRead, F02Z, PGE.INI, HotSpots, F02Z, 0
                                       
  IniRead, F03X, PGE.INI, HotSpots, F03X, 0
  IniRead, F03Y, PGE.INI, HotSpots, F03Y, 0
  IniRead, F03Z, PGE.INI, HotSpots, F03Z, 0
                                       
  IniRead, F04X, PGE.INI, HotSpots, F04X, 0
  IniRead, F04Y, PGE.INI, HotSpots, F04Y, 0
  IniRead, F04Z, PGE.INI, HotSpots, F04Z, 0
                                       
  IniRead, F05X, PGE.INI, HotSpots, F05X, 0
  IniRead, F05Y, PGE.INI, HotSpots, F05Y, 0
  IniRead, F05Z, PGE.INI, HotSpots, F05Z, 0
                                       
  IniRead, F06X, PGE.INI, HotSpots, F06X, 0
  IniRead, F06Y, PGE.INI, HotSpots, F06Y, 0
  IniRead, F06Z, PGE.INI, HotSpots, F06Z, 0
                                       
  IniRead, F07X, PGE.INI, HotSpots, F07X, 0
  IniRead, F07Y, PGE.INI, HotSpots, F07Y, 0
  IniRead, F07Z, PGE.INI, HotSpots, F07Z, 0
                                       
  IniRead, F08X, PGE.INI, HotSpots, F08X, 0
  IniRead, F08Y, PGE.INI, HotSpots, F08Y, 0
  IniRead, F08Z, PGE.INI, HotSpots, F08Z, 0
                                       
  IniRead, F09X, PGE.INI, HotSpots, F09X, 0
  IniRead, F09Y, PGE.INI, HotSpots, F09Y, 0
  IniRead, F09Z, PGE.INI, HotSpots, F09Z, 0
                                       
  IniRead, F10X, PGE.INI, HotSpots, F10X, 0
  IniRead, F10Y, PGE.INI, HotSpots, F10Y, 0
  IniRead, F10Z, PGE.INI, HotSpots, F10Z, 0
                                       
  IniRead, F11X, PGE.INI, HotSpots, F11X, 0
  IniRead, F11Y, PGE.INI, HotSpots, F11Y, 0
  IniRead, F11Z, PGE.INI, HotSpots, F11Z, 0
                                       
  IniRead, F12X, PGE.INI, HotSpots, F12X, 0
  IniRead, F12Y, PGE.INI, HotSpots, F12Y, 0
  IniRead, F12Z, PGE.INI, HotSpots, F12Z, 0
}

; -------------------------------------------------------------------
; ----- Look for specific Window names associated with the CO2 ------
; -------------------------------------------------------------------

GroupAdd, PGGameSeries, Command Ops 2
GroupAdd, PGGameSeries, Controls
#IfWinActive ahk_group PGGameSeries

; -------------------------------------
; ----- Key Bindings, Numbers 1-6 -----
; -------------------------------------

1:: ; <========================================================= NUMBER 1
If GetKeyState("RButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetDefZoom(1, 0)
  BlockInput, Off
  Return
}
If GetKeyState("LButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetLocZoom(1)
  JumpLoc(LastFKey, 1)
  BlockInput, Off
  Return
}
Send 1
Return

2:: ; <========================================================= NUMBER 2
If GetKeyState("RButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetDefZoom(2, 0)
  BlockInput, Off
  Return
}
If GetKeyState("LButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetLocZoom(2)
  JumpLoc(LastFKey, 1)
  BlockInput, Off
  Return
}
Send 2
Return

3:: ; <========================================================= NUMBER 3
If GetKeyState("RButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetDefZoom(3, 0)
  BlockInput, Off
  Return
}
If GetKeyState("LButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetLocZoom(3)
  JumpLoc(LastFKey, 1)
  BlockInput, Off
  Return
}
Send 3
Return

; --------------------------------------------
; ----- Key Bindings, Function Keys 1-12 -----
; --------------------------------------------

F1:: ; <========================================================= Function Key 01
If GetKeyState("RButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  JumpLoc(1, 0)
  BlockInput, Off
  Return
}
If GetKeyState("LButton")
{
  OnStratMap()
  If !CursorOnStratMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetLoc(1)
  JumpLoc(LastFKey, 0)
  BlockInput, Off
  Return
}
Send {F1}
Return

F2:: ; <========================================================= Function Key 02
If GetKeyState("RButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  JumpLoc(2, 0)
  BlockInput, Off
  Return
}
If GetKeyState("LButton")
{
  OnStratMap()
  If !CursorOnStratMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetLoc(2)
  JumpLoc(LastFKey, 0)
  BlockInput, Off
  Return
}
Send {F2}
Return

F3:: ; <========================================================= Function Key 03
If GetKeyState("RButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  JumpLoc(3, 0)
  BlockInput, Off
  Return
}
If GetKeyState("LButton")
{
  OnStratMap()
  If !CursorOnStratMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetLoc(3)
  JumpLoc(LastFKey, 0)
  BlockInput, Off
  Return
}
Send {F3}
Return

F4:: ; <========================================================= Function Key 04
If GetKeyState("RButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  JumpLoc(4, 0)
  BlockInput, Off
  Return
}
If GetKeyState("LButton")
{
  OnStratMap()
  If !CursorOnStratMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetLoc(4)
  JumpLoc(LastFKey, 0)
  BlockInput, Off
  Return
}
Send {F4}
Return

F5:: ; <========================================================= Function Key 05
If GetKeyState("RButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  JumpLoc(5, 0)
  BlockInput, Off
  Return
}
If GetKeyState("LButton")
{
  OnStratMap()
  If !CursorOnStratMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetLoc(5)
  JumpLoc(LastFKey, 0)
  BlockInput, Off
  Return
}
Send {F5}
Return

F6:: ; <========================================================= Function Key 06
If GetKeyState("RButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  JumpLoc(6, 0)
  BlockInput, Off
  Return
}
If GetKeyState("LButton")
{
  OnStratMap()
  If !CursorOnStratMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetLoc(6)
  JumpLoc(LastFKey, 0)
  BlockInput, Off
  Return
}
Send {F6}
Return

F7:: ; <========================================================= Function Key 07
If GetKeyState("RButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  JumpLoc(7, 0)
  BlockInput, Off
  Return
}
If GetKeyState("LButton")
{
  OnStratMap()
  If !CursorOnStratMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetLoc(7)
  JumpLoc(LastFKey, 0)
  BlockInput, Off
  Return
}
Send {F7}
Return

F8:: ; <========================================================= Function Key 08
If GetKeyState("RButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  JumpLoc(8, 0)
  BlockInput, Off
  Return
}
If GetKeyState("LButton")
{
  OnStratMap()
  If !CursorOnStratMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetLoc(8)
  JumpLoc(LastFKey, 0)
  BlockInput, Off
  Return
}
Send {F8}
Return

F9:: ; <========================================================= Function Key 09
If GetKeyState("RButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  JumpLoc(9, 0)
  BlockInput, Off
  Return
}
If GetKeyState("LButton")
{
  OnStratMap()
  If !CursorOnStratMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetLoc(9)
  JumpLoc(LastFKey, 0)
  BlockInput, Off
  Return
}
Send {F9}
Return

F10:: ; <======================================================== Function Key 10
If GetKeyState("RButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  JumpLoc(10, 0)
  BlockInput, Off
  Return
}
If GetKeyState("LButton")
{
  OnStratMap()
  If !CursorOnStratMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetLoc(10)
  JumpLoc(LastFKey, 0)
  BlockInput, Off
  Return
}
Send {F10}
Return

F11:: ; <======================================================== Function Key 11
If GetKeyState("RButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  JumpLoc(11, 0)
  BlockInput, Off
  Return
}
If GetKeyState("LButton")
{
  OnStratMap()
  If !CursorOnStratMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetLoc(11)
  JumpLoc(LastFKey, 0)
  BlockInput, Off
  Return
}
Send {F11}
Return

F12:: ; <======================================================== Function Key 12
If GetKeyState("RButton")
{
  OnTacMap()
  If !CursorOnTacMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  JumpLoc(12, 0)
  BlockInput, Off
  Return
}
If GetKeyState("LButton")
{
  OnStratMap()
  If !CursorOnStratMap
  {
    Return
  }
  BlockInput, On
  MouseClick, right, , , 1, 2, U
  MouseClick, left, , , 1, 2, U
  SetLoc(12)
  JumpLoc(LastFKey, 0)
  BlockInput, Off
  Return
}
Send {F12}
Return

; --------------------------------
; ----- Key Bindings, Arrows -----
; --------------------------------

Left:: ; <======================================================= Left
If GetKeyState("LButton")
{
  OnStratMap()
  If CursorOnStratMap
  {
    Return
  }
  BlockInput, On
  NudgeLeft(LastFKey)
  JumpLoc(LastFKey, 1)
  BlockInput, Off
  MouseClick, left, , , 1, 2, D
  Return
}
Send {Left}
Return

Right:: ; <====================================================== Right
If GetKeyState("LButton")
{
  OnStratMap()
  If CursorOnStratMap
  {
    Return
  }
  BlockInput, On
  NudgeRight(LastFKey)
  JumpLoc(LastFKey, 1)
  BlockInput, Off
  MouseClick, left, , , 1, 2, D
  Return
}
Send {Right}
Return

Up:: ; <========================================================= Up
If GetKeyState("LButton")
{
  OnStratMap()
  If CursorOnStratMap
  {
    Return
  }
  BlockInput, On
  NudgeUp(LastFKey)
  JumpLoc(LastFKey, 1)
  BlockInput, Off
  MouseClick, left, , , 1, 2, D
  Return
}
Send {Up}
Return

Down:: ; <======================================================= Down
If GetKeyState("LButton")
{
  OnStratMap()
  If CursorOnStratMap
  {
    Return
  }
  BlockInput, On
  NudgeDown(LastFKey)
  JumpLoc(LastFKey, 1)
  BlockInput, Off
  MouseClick, left, , , 1, 2, D
  Return
}
Send {Down}
Return

; #####################
; ##### Functions #####
; #####################

; ----------------------
; ----- SetDefZoom -----
; ----------------------

SetDefZoom(ZoomLevel, NoSound) ; Set or reset the default zoom level.
{                              ; This overrides any previous settings!
  Global DelaySound

  Global F01Z
  Global F02Z
  Global F03Z
  Global F04Z
  Global F05Z
  Global F06Z
  Global F07Z
  Global F08Z
  Global F09Z
  Global F10Z
  Global F11Z
  Global F12Z

  F01Z:=ZoomLevel
  F02Z:=ZoomLevel
  F03Z:=ZoomLevel
  F04Z:=ZoomLevel
  F05Z:=ZoomLevel
  F06Z:=ZoomLevel
  F07Z:=ZoomLevel
  F08Z:=ZoomLevel
  F09Z:=ZoomLevel
  F10Z:=ZoomLevel
  F11Z:=ZoomLevel
  F12Z:=ZoomLevel

  If !NoSound ; no sound needed for program initialization
  {
    SoundPlay *-1 ; triple ding confirmation
    Sleep DelaySound
    SoundPlay *-1
    Sleep DelaySound
    SoundPlay *-1
    Sleep DelaySound
  }
  Return
}

; ----------------------
; ----- SetLocZoom -----
; ----------------------

SetLocZoom(ZoomLevel) ; Set the location zoom level
{
  Global DelaySound
  Global LastFKey

  Global F01Z
  Global F02Z
  Global F03Z
  Global F04Z
  Global F05Z
  Global F06Z
  Global F07Z
  Global F08Z
  Global F09Z
  Global F10Z
  Global F11Z
  Global F12Z

  If LastFKey=0
  {
    Return
  }
  If      LastFKey=1  
                      F01Z:=ZoomLevel
  Else if LastFKey=2
                      F02Z:=ZoomLevel
  Else if LastFKey=3
                      F03Z:=ZoomLevel
  Else if LastFKey=4
                      F04Z:=ZoomLevel
  Else if LastFKey=5
                      F05Z:=ZoomLevel
  Else if LastFKey=6
                      F06Z:=ZoomLevel
  Else if LastFKey=7
                      F07Z:=ZoomLevel
  Else if LastFKey=8
                      F08Z:=ZoomLevel
  Else if LastFKey=9
                      F09Z:=ZoomLevel
  Else if LastFKey=10
                      F10Z:=ZoomLevel
  Else if LastFKey=11
                      F11Z:=ZoomLevel
  Else if LastFKey=12
                      F12Z:=ZoomLevel

  SoundPlay *-1 ; double ding confirmation
  Sleep DelaySound
  SoundPlay *-1
  Sleep DelaySound

  Return
}

; ------------------
; ----- SetLoc -----
; ------------------

SetLoc(FKeyID) ; Set the location hot spot
{
  Global DelaySound
  Global LastFKey
  Global CursorOnStratMap

  Global F01X
  Global F01Y
  Global F02X
  Global F02Y
  Global F03X
  Global F03Y
  Global F04X
  Global F04Y
  Global F05X
  Global F05Y
  Global F06X
  Global F06Y
  Global F07X
  Global F07Y
  Global F08X
  Global F08Y
  Global F09X
  Global F09Y
  Global F10X
  Global F10Y
  Global F11X
  Global F11Y
  Global F12X
  Global F12Y

  MouseGetPos, XPos, YPos
 
  LastFKey:=FKeyID

  If      FKeyID=1  
  {
                      F01X:=XPos
                      F01Y:=YPos
  }
  Else if FKeyID=2
  {
                      F02X:=XPos
                      F02Y:=YPos
  }
  Else if FKeyID=3
  {
                      F03X:=XPos
                      F03Y:=YPos
  }
  Else if FKeyID=4
  {
                      F04X:=XPos
                      F04Y:=YPos
  }
  Else if FKeyID=5
  {
                      F05X:=XPos
                      F05Y:=YPos
  }
  Else if FKeyID=6
  {
                      F06X:=XPos
                      F06Y:=YPos
  }
  Else if FKeyID=7
  {
                      F07X:=XPos
                      F07Y:=YPos
  }
  Else if FKeyID=8
  {
                      F08X:=XPos
                      F08Y:=YPos
  }
  Else if FKeyID=9
  {
                      F09X:=XPos
                      F09Y:=YPos
  }
  Else if FKeyID=10
  {
                      F10X:=XPos
                      F10Y:=YPos
  }
  Else if FKeyID=11
  {
                      F11X:=XPos
                      F11Y:=YPos
  }
  Else if FKeyID=12
  {
                      F12X:=XPos
                      F12Y:=YPos
  }
  
  SoundPlay *-1 ; single ding confirmation
  Sleep DelaySound

  Return
}

; -------------------
; ----- JumpLoc -----
; -------------------

JumpLoc(FKeyID, Nudge) ; Jump to the location hot spot and adjust zoom
{
  Global LastFKey
  Global DelayZoom
  Global DelayMap

  Global F01X
  Global F01Y
  Global F01Z
  Global F02X
  Global F02Y
  Global F02Z
  Global F03X
  Global F03Y
  Global F03Z
  Global F04X
  Global F04Y
  Global F04Z
  Global F05X
  Global F05Y
  Global F05Z
  Global F06X
  Global F06Y
  Global F06Z
  Global F07X
  Global F07Y
  Global F07Z
  Global F08X
  Global F08Y
  Global F08Z
  Global F09X
  Global F09Y
  Global F09Z
  Global F10X
  Global F10Y
  Global F10Z
  Global F11X
  Global F11Y
  Global F11Z
  Global F12X
  Global F12Y
  Global F12Z

  LastFKey:=FKeyID

; ----- Do nothing if the location is not set -----

  If FKeyID=1
  {
    If F01X=0
    {
      Return
    }
  }
  If FKeyID=2
  {
    If F02X=0
    {
      Return
    }
  }
  If FKeyID=3
  {
    If F03X=0
    {
      Return
    }
  }
  If FKeyID=4
  {
    If F04X=0
    {
      Return
    }
  }
  If FKeyID=5
  {
    If F05X=0
    {
      Return
    }
  }
  If FKeyID=6
  {
    If F06X=0
    {
      Return
    }
  }
  If FKeyID=7
  {
    If F07X=0
    {
      Return
    }
  }
  If FKeyID=8
  {
    If F08X=0
    {
      Return
    }
  }
  If FKeyID=9
  {
    If F09X=0
    {
      Return
    }
  }
  If FKeyID=10
  {
    If F10X=0
    {
      Return
    }
  }
  If FKeyID=11
  {
    If F11X=0
    {
      Return
    }
  }
  If FKeyID=12
  {
    If F12X=0
    {
      Return
    }
  }

; ----- Zoom into the max (level 1) -----

  WinActivate, Command Ops 2,
  WinGetActiveStats, Dummy1, ScreenWidth, ScreenHeight, Dummy4, Dummy5
  SXPos:=ScreenWidth/2
  SYPos:=ScreenHeight/2
  MouseMove, SXPos, SYPos, 0

  BlockInput, Off
  Sleep, 1000,
  Loop, 8
  {
    If MR
    {
      SendInput {WheelDown}
    }
    Else
    {
      SendInput {WheelUp}
    }
    Sleep, 1000,
  }
  Sleep, 1000,
  BlockInput, On

; ----- Position the map -----

  WinActivate, Controls,
  Sleep, DelayMap

  ;If Nudge ; nudging requires reseting the landing zone
  ;{
    TX:=70 ; map center (reset landing zone)
    TY:=86 ; map center (reset landing zone)
    If FKeyId=1
                      {
                        If ((F01X > 40) AND (F01X < 100)) OR ((F01Y > 56) AND (F01Y < 116))
                        {
                          TX:=8 ; map corner (reset landing zone)
                          TY:=24 ; map corner (reset landing zone)
                        }
                      }
    Else If FKeyId=2
                      {
                        If ((F02X > 40) AND (F02X < 100)) OR ((F01Y > 56) AND (F01Y < 116))
                        {
                          TX:=8 ; map corner (reset landing zone)
                          TY:=24 ; map corner (reset landing zone)
                        }
                      }
    Else If FKeyId=3
                      {
                        If ((F03X > 40) AND (F03X < 100)) OR ((F03Y > 56) AND (F03Y < 116))
                        {
                          TX:=8 ; map corner (reset landing zone)
                          TY:=24 ; map corner (reset landing zone)
                        }
                      }
    Else If FKeyId=4
                      {
                        If ((F04X > 40) AND (F04X < 100)) OR ((F04Y > 56) AND (F04Y < 116))
                        {
                          TX:=8 ; map corner (reset landing zone)
                          TY:=24 ; map corner (reset landing zone)
                        }
                      }
    Else If FKeyId=5
                      {
                        If ((F05X > 40) AND (F05X < 100)) OR ((F05Y > 56) AND (F05Y < 116))
                        {
                          TX:=8 ; map corner (reset landing zone)
                          TY:=24 ; map corner (reset landing zone)
                        }
                      }
    Else If FKeyId=6
                      {
                        If ((F06X > 40) AND (F06X < 100)) OR ((F06Y > 56) AND (F06Y < 116))
                        {
                          TX:=8 ; map corner (reset landing zone)
                          TY:=24 ; map corner (reset landing zone)
                        }
                      }
    Else If FKeyId=7
                      {
                        If ((F07X > 40) AND (F07X < 100)) OR ((F07Y > 56) AND (F07Y < 116))
                        {
                          TX:=8 ; map corner (reset landing zone)
                          TY:=24 ; map corner (reset landing zone)
                        }
                      }
    Else If FKeyId=8
                      {
                        If ((F08X > 40) AND (F08X < 100)) OR ((F08Y > 56) AND (F08Y < 116))
                        {
                          TX:=8 ; map corner (reset landing zone)
                          TY:=24 ; map corner (reset landing zone)
                        }
                      }
    Else If FKeyId=9
                      {
                        If ((F09X > 40) AND (F09X < 100)) OR ((F09Y > 56) AND (F09Y < 116))
                        {
                          TX:=8 ; map corner (reset landing zone)
                          TY:=24 ; map corner (reset landing zone)
                        }
                      }
    Else If FKeyId=10
                      {
                        If ((F10X > 40) AND (F10X < 100)) OR ((F10Y > 56) AND (F10Y < 116))
                        {
                          TX:=8 ; map corner (reset landing zone)
                          TY:=24 ; map corner (reset landing zone)
                        }
                      }
    Else If FKeyId=11
                      {
                        If ((F11X > 40) AND (F11X < 100)) OR ((F11Y > 56) AND (F11Y < 116))
                        {
                          TX:=8 ; map corner (reset landing zone)
                          TY:=24 ; map corner (reset landing zone)
                        }
                      }
    Else If FKeyId=12
                      {
                        If ((F12X > 40) AND (F12X < 100)) OR ((F12Y > 56) AND (F12Y < 116))
                        {
                          TX:=8 ; map corner (reset landing zone)
                          TY:=24 ; map corner (reset landing zone)
                        }
                      }
    MouseClick, left, , , 1, 2, U
    MouseClick, left, TX, TY
    Sleep 1
    Sleep, 1
    WinActivate, Command Ops 2,
    WinGetActiveStats, Dummy1, ScreenWidth, ScreenHeight, Dummy4, Dummy5
    SXPos:=ScreenWidth/2
    SYPos:=ScreenHeight/2
    MouseMove, SXPos, SYPos, 0
    Sleep, 50
    WinActivate, Controls,
    Sleep, DelayMap
  ;}

  If FKeyId=1
                    {
                    MouseClick, left, F01X, F01Y
                    }
  Else If FKeyId=2
                    {
                    MouseClick, left, F02X, F02Y
                    }
  Else If FKeyId=3
                    {
                    MouseClick, left, F03X, F03Y
                    }
  Else If FKeyId=4
                    {
                    MouseClick, left, F04X, F04Y
                    }
  Else If FKeyId=5
                    {
                    MouseClick, left, F05X, F05Y
                    }
  Else If FKeyId=6
                    {
                    MouseClick, left, F06X, F06Y
                    }
  Else If FKeyId=7
                    {
                    MouseClick, left, F07X, F07Y
                    }
  Else If FKeyId=8
                    {
                    MouseClick, left, F08X, F09Y
                    }
  Else If FKeyId=9
                    {
                    MouseClick, left, F09X, F09Y
                    }
  Else If FKeyId=10
                    {
                    MouseClick, left, F10X, F10Y
                    }
  Else If FKeyId=11
                    {
                    MouseClick, left, F11X, F11Y
                    }
  Else If FKeyId=12
                    {
                    MouseClick, left, F12X, F12Y
                    }
  Sleep, DelayMap

; ----- Center the mouse position on the map -----

  WinActivate, Command Ops 2,
  WinGetActiveStats, Dummy1, ScreenWidth, ScreenHeight, Dummy4, Dummy5
  SXPos:=ScreenWidth/2
  SYPos:=ScreenHeight/2
  MouseMove, SXPos, SYPos, 0

  Sleep, DelayMap

; ----- Adjust the zoom level -----

  If FKeyId=1
                    ZoomAdjust:=F01Z
  Else If FKeyId=2
                    ZoomAdjust:=F02Z
  Else If FKeyId=3
                    ZoomAdjust:=F03Z
  Else If FKeyId=4
                    ZoomAdjust:=F04Z
  Else If FKeyId=5
                    ZoomAdjust:=F05Z
  Else If FKeyId=6
                    ZoomAdjust:=F06Z
  Else If FKeyId=7
                    ZoomAdjust:=F07Z
  Else If FKeyId=8
                    ZoomAdjust:=F08Z
  Else If FKeyId=9
                    ZoomAdjust:=F09Z
  Else If FKeyId=10
                    ZoomAdjust:=F10Z
  Else If FKeyId=11
                    ZoomAdjust:=F11Z
  Else If FKeyId=12
                    ZoomAdjust:=F12Z

  BlockInput, Off
  ZoomAdjust:=ZoomAdjust-1
  Sleep, 1000,
  Loop, %ZoomAdjust%
  {
    If MR
    {
      SendInput {WheelUp}
    }
    Else
    {
      SendInput {WheelDown}
    }
    Sleep, 1000,
  }
  Sleep, 1000,
  BlockInput, On

; ----- Center the mouse position on the map -----

  WinActivate, Command Ops 2,
  WinGetActiveStats, Dummy1, ScreenWidth, ScreenHeight, Dummy4, Dummy5
  SXPos:=ScreenWidth/2
  SYPos:=ScreenHeight/2
  MouseMove, SXPos, SYPos, 0

  Sleep, DelayMap

  Return
}

; -----------------------
; ----- ExitHandler -----
; -----------------------

ExitHandler: ; Save INI Values
{
  IniWrite, %F01X%, PGE.INI, HotSpots, F01X
  IniWrite, %F01Y%, PGE.INI, HotSpots, F01Y
  IniWrite, %F01Z%, PGE.INI, HotSpots, F01Z
                                           
  IniWrite, %F02X%, PGE.INI, HotSpots, F02X
  IniWrite, %F02Y%, PGE.INI, HotSpots, F02Y
  IniWrite, %F02Z%, PGE.INI, HotSpots, F02Z
                                           
  IniWrite, %F03X%, PGE.INI, HotSpots, F03X
  IniWrite, %F03Y%, PGE.INI, HotSpots, F03Y
  IniWrite, %F03Z%, PGE.INI, HotSpots, F03Z
                                           
  IniWrite, %F04X%, PGE.INI, HotSpots, F04X
  IniWrite, %F04Y%, PGE.INI, HotSpots, F04Y
  IniWrite, %F04Z%, PGE.INI, HotSpots, F04Z
                                           
  IniWrite, %F05X%, PGE.INI, HotSpots, F05X
  IniWrite, %F05Y%, PGE.INI, HotSpots, F05Y
  IniWrite, %F05Z%, PGE.INI, HotSpots, F05Z
                                           
  IniWrite, %F06X%, PGE.INI, HotSpots, F06X
  IniWrite, %F06Y%, PGE.INI, HotSpots, F06Y
  IniWrite, %F06Z%, PGE.INI, HotSpots, F06Z
                                           
  IniWrite, %F07X%, PGE.INI, HotSpots, F07X
  IniWrite, %F07Y%, PGE.INI, HotSpots, F07Y
  IniWrite, %F07Z%, PGE.INI, HotSpots, F07Z
                                           
  IniWrite, %F08X%, PGE.INI, HotSpots, F08X
  IniWrite, %F08Y%, PGE.INI, HotSpots, F08Y
  IniWrite, %F08Z%, PGE.INI, HotSpots, F08Z
                                           
  IniWrite, %F09X%, PGE.INI, HotSpots, F09X
  IniWrite, %F09Y%, PGE.INI, HotSpots, F09Y
  IniWrite, %F09Z%, PGE.INI, HotSpots, F09Z
                                           
  IniWrite, %F10X%, PGE.INI, HotSpots, F10X
  IniWrite, %F10Y%, PGE.INI, HotSpots, F10Y
  IniWrite, %F10Z%, PGE.INI, HotSpots, F10Z
                                           
  IniWrite, %F11X%, PGE.INI, HotSpots, F11X
  IniWrite, %F11Y%, PGE.INI, HotSpots, F11Y
  IniWrite, %F11Z%, PGE.INI, HotSpots, F11Z
                                           
  IniWrite, %F12X%, PGE.INI, HotSpots, F12X
  IniWrite, %F12Y%, PGE.INI, HotSpots, F12Y
  IniWrite, %F12Z%, PGE.INI, HotSpots, F12Z

  ExitApp
}

; ---------------------
; ----- NudgeLeft -----
; ---------------------

NudgeLeft(FKeyID) ; Set the location hot spot
{
  Global DelaySound

  Global F01X
  Global F01Y
  Global F02X
  Global F02Y
  Global F03X
  Global F03Y
  Global F04X
  Global F04Y
  Global F05X
  Global F05Y
  Global F06X
  Global F06Y
  Global F07X
  Global F07Y
  Global F08X
  Global F08Y
  Global F09X
  Global F09Y
  Global F10X
  Global F10Y
  Global F11X
  Global F11Y
  Global F12X
  Global F12Y

  If      FKeyID=1
  {
                      If (F01X>7)
                                  F01X:=F01X-1
  }
  Else if FKeyID=2                         
  {
                      If (F02X>7)          
                                  F02X:=F02X-1
  }
  Else if FKeyID=3                         
  {
                      If (F03X>7)          
                                  F03X:=F03X-1
  }
  Else if FKeyID=4                         
  {
                      If (F04X>7)          
                                  F04X:=F04X-1
  }
  Else if FKeyID=5                         
  {
                      If (F05X>7)          
                                  F05X:=F05X-1
  }
  Else if FKeyID=6                         
  {
                      If (F06X>7)          
                                  F06X:=F06X-1
  }
  Else if FKeyID=7                         
  {
                      If (F07X>7)          
                                  F07X:=F07X-1
  }
  Else if FKeyID=8                         
  {
                      If (F08X>7)          
                                  F08X:=F08X-1
  }
  Else if FKeyID=9                         
  {
                      If (F09X>7)          
                                  F09X:=F09X-1
  }
  Else if FKeyID=10                        
  {
                      If (F10X>7)          
                                  F10X:=F10X-1
  }
  Else if FKeyID=11                        
  {
                      If (F11X>7)          
                                  F11X:=F11X-1
  }
  Else if FKeyID=12                        
  {
                      If (F12X>7)          
                                  F12X:=F12X-1
  } 
  Return
}

; -------------------
; ----- NudgeUp -----
; -------------------

NudgeUp(FKeyID) ; Set the location hot spot
{
  Global DelaySound

  Global F01X
  Global F01Y
  Global F02X
  Global F02Y
  Global F03X
  Global F03Y
  Global F04X
  Global F04Y
  Global F05X
  Global F05Y
  Global F06X
  Global F06Y
  Global F07X
  Global F07Y
  Global F08X
  Global F08Y
  Global F09X
  Global F09Y
  Global F10X
  Global F10Y
  Global F11X
  Global F11Y
  Global F12X
  Global F12Y

  If      FKeyID=1
  {
                      If (F01Y>23)
                                  F01Y:=F01Y-1
  }
  Else if FKeyID=2                         
  {
                      If (F02Y>23)          
                                  F02Y:=F02Y-1
  }
  Else if FKeyID=3                         
  {
                      If (F03Y>23)          
                                  F03Y:=F03Y-1
  }
  Else if FKeyID=4                         
  {
                      If (F04Y>23)          
                                  F04Y:=F04Y-1
  }
  Else if FKeyID=5                         
  {
                      If (F05Y>23)          
                                  F05Y:=F05Y-1
  }
  Else if FKeyID=6                         
  {
                      If (F06Y>23)          
                                  F06Y:=F06Y-1
  }
  Else if FKeyID=7                         
  {
                      If (F07Y>23)          
                                  F07Y:=F07Y-1
  }
  Else if FKeyID=8                         
  {
                      If (F08Y>23)          
                                  F08Y:=F08Y-1
  }
  Else if FKeyID=9                         
  {
                      If (F09Y>23)          
                                  F09Y:=F09Y-1
  }
  Else if FKeyID=10                        
  {
                      If (F10Y>23)          
                                  F10Y:=F10Y-1
  }
  Else if FKeyID=11                        
  {
                      If (F11Y>23)          
                                  F11Y:=F11Y-1
  }
  Else if FKeyID=12                        
  {
                      If (F12Y>23)          
                                  F12Y:=F12Y-1
  } 
  Return
}

; ----------------------
; ----- NudgeRight -----
; ----------------------

NudgeRight(FKeyID) ; Set the location hot spot
{
  Global DelaySound

  Global F01X
  Global F01Y
  Global F02X
  Global F02Y
  Global F03X
  Global F03Y
  Global F04X
  Global F04Y
  Global F05X
  Global F05Y
  Global F06X
  Global F06Y
  Global F07X
  Global F07Y
  Global F08X
  Global F08Y
  Global F09X
  Global F09Y
  Global F10X
  Global F10Y
  Global F11X
  Global F11Y
  Global F12X
  Global F12Y

  If      FKeyID=1
  {
                      If (F01X<133)
                                  F01X:=F01X+1
  }
  Else if FKeyID=2                         
  {
                      If (F02X<133)          
                                  F02X:=F02X+1
  }
  Else if FKeyID=3                         
  {
                      If (F03X<133)          
                                  F03X:=F03X+1
  }
  Else if FKeyID=4                         
  {
                      If (F04X<133)          
                                  F04X:=F04X+1
  }
  Else if FKeyID=5                         
  {
                      If (F05X<133)          
                                  F05X:=F05X+1
  }
  Else if FKeyID=6                         
  {
                      If (F06X<133)          
                                  F06X:=F06X+1
  }
  Else if FKeyID=7                         
  {
                      If (F07X<133)          
                                  F07X:=F07X+1
  }
  Else if FKeyID=8                         
  {
                      If (F08X<133)          
                                  F08X:=F08X+1
  }
  Else if FKeyID=9                         
  {
                      If (F09X<133)          
                                  F09X:=F09X+1
  }
  Else if FKeyID=10                        
  {
                      If (F10X<133)          
                                  F10X:=F10X+1
  }
  Else if FKeyID=11                        
  {
                      If (F11X<133)          
                                  F11X:=F11X+1
  }
  Else if FKeyID=12                        
  {
                      If (F12X<133)          
                                  F12X:=F12X+1
  } 
  Return
}

; ---------------------
; ----- NudgeDown -----
; ---------------------

NudgeDown(FKeyID) ; Set the location hot spot
{
  Global DelaySound

  Global F01X
  Global F01Y
  Global F02X
  Global F02Y
  Global F03X
  Global F03Y
  Global F04X
  Global F04Y
  Global F05X
  Global F05Y
  Global F06X
  Global F06Y
  Global F07X
  Global F07Y
  Global F08X
  Global F08Y
  Global F09X
  Global F09Y
  Global F10X
  Global F10Y
  Global F11X
  Global F11Y
  Global F12X
  Global F12Y

  If      FKeyID=1
  {
                      If (F01Y<150)
                                  F01Y:=F01Y+1
  }
  Else if FKeyID=2                         
  {
                      If (F02Y<150)          
                                  F02Y:=F02Y+1
  }
  Else if FKeyID=3                         
  {
                      If (F03Y<150)          
                                  F03Y:=F03Y+1
  }
  Else if FKeyID=4                         
  {
                      If (F04Y<150)          
                                  F04Y:=F04Y+1
  }
  Else if FKeyID=5                         
  {
                      If (F05Y<150)          
                                  F05Y:=F05Y+1
  }
  Else if FKeyID=6                         
  {
                      If (F06Y<150)          
                                  F06Y:=F06Y+1
  }
  Else if FKeyID=7                         
  {
                      If (F07Y<150)          
                                  F07Y:=F07Y+1
  }
  Else if FKeyID=8                         
  {
                      If (F08Y<150)          
                                  F08Y:=F08Y+1
  }
  Else if FKeyID=9                         
  {
                      If (F09Y<150)          
                                  F09Y:=F09Y+1
  }
  Else if FKeyID=10                        
  {
                      If (F10Y<150)          
                                  F10Y:=F10Y+1
  }
  Else if FKeyID=11                        
  {
                      If (F11Y<150)          
                                  F11Y:=F11Y+1
  }
  Else if FKeyID=12                        
  {
                      If (F12Y<150)          
                                  F12Y:=F12Y+1
  } 
  Return
}

; ----------------------
; ----- OnStratMap -----
; ----------------------

OnStratMap()
{
  Global CursorOnStratMap

  CursorOnStratMap:=1
  IfWinActive, Controls,
  {
    MouseGetPos, XPos, YPos
  
    If XPos<8
    {
      CursorOnStratMap:=0
    }
    If XPos>132
    {
      CursorOnStratMap:=0
    }
    If YPos<24
    {
      CursorOnStratMap:=0
    }
    If YPos>149
    {
      CursorOnStratMap:=0
    }
  }
  Else
  {
    CursorOnStratMap:=0
  }
  Return
}

; ----------------------
; ----- OnTacMap -----
; ----------------------

OnTacMap()
{
  Global CursorOnTacMap

  IfWinActive, Command Ops 2,
  {
    CursorOnTacMap:=1
  }
  Else
  {
    CursorOnTacMap:=0
  }
  Return
}
